#!/usr/bin/python

def longest_increasing_subsequence(scores):
    if len(scores)==0: return []
    dp = [1] * len(scores) # Every score starts as a subsequence of length 1.
    backpointer = [None] * len(dp)
    for i in range(len(dp)):
        for prev in range(i):
            if scores[prev] < scores[i]: # Increasing score.
                if dp[i] < dp[prev]+1:   # Bigger subsequence length.
                    dp[i] = dp[prev]+1
                    backpointer[i] = prev
    reverse_ans = []
    index = 0
    for i in range(len(dp)):
        if dp[i] > dp[index]: index = i
    while backpointer[index] is not None:
        reverse_ans.append(scores[index])
        index = backpointer[index]
    reverse_ans.append(scores[index])
    reverse_ans.reverse()
    return reverse_ans
